import{s as te,n as ae,o as re}from"../chunks/scheduler.85c25b89.js";import{S as oe,i as ne,g as s,s as n,r as D,A as ie,h as m,f as t,c as i,j as w,u as F,x as B,k as N,y as x,a as r,v as k,d as R,t as S,w as j}from"../chunks/index.c9837788.js";import{D as V}from"../chunks/Docstring.7e31ccde.js";import{H as se,E as me}from"../chunks/EditOnGithub.b65eee75.js";function ce(K){let c,I,T,C,d,L,o,p,G,y,J="Dataset factory method",M,$,Q="In parentheses after each arg are the type of dataset supported for each arg, one of:",q,z,X="<li>folder - default, timm folder (or tar) based ImageDataset</li> <li>torch - torchvision based datasets</li> <li>HFDS - Hugging Face Datasets</li> <li>TFDS - Tensorflow-datasets wrapper in IterabeDataset interface via IterableImageDataset</li> <li>WDS - Webdataset</li> <li>all - any of the above</li>",P,g,_,E,f,u,U,h,b,H,v,W,O,A;return d=new se({props:{title:"Data",local:"timm.data.create_dataset",headingTag:"h1"}}),p=new V({props:{name:"timm.data.create_dataset",anchor:"timm.data.create_dataset",parameters:[{name:"name",val:": str"},{name:"root",val:": Optional = None"},{name:"split",val:": str = 'validation'"},{name:"search_split",val:": bool = True"},{name:"class_map",val:": dict = None"},{name:"load_bytes",val:": bool = False"},{name:"is_training",val:": bool = False"},{name:"download",val:": bool = False"},{name:"batch_size",val:": int = 1"},{name:"num_samples",val:": Optional = None"},{name:"seed",val:": int = 42"},{name:"repeats",val:": int = 0"},{name:"input_img_mode",val:": str = 'RGB'"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"timm.data.create_dataset.name",description:"<strong>name</strong> &#x2014; dataset name, empty is okay for folder based datasets",name:"name"},{anchor:"timm.data.create_dataset.root",description:"<strong>root</strong> &#x2014; root folder of dataset (all)",name:"root"},{anchor:"timm.data.create_dataset.split",description:"<strong>split</strong> &#x2014; dataset split (all)",name:"split"},{anchor:"timm.data.create_dataset.search_split",description:`<strong>search_split</strong> &#x2014; search for split specific child fold from root so one can specify
<code>imagenet/</code> instead of <code>/imagenet/val</code>, etc on cmd line / config. (folder, torch/folder)`,name:"search_split"},{anchor:"timm.data.create_dataset.class_map",description:"<strong>class_map</strong> &#x2014; specify class -&gt; index mapping via text file or dict (folder)",name:"class_map"},{anchor:"timm.data.create_dataset.load_bytes",description:"<strong>load_bytes</strong> &#x2014; load data, return images as undecoded bytes (folder)",name:"load_bytes"},{anchor:"timm.data.create_dataset.download",description:"<strong>download</strong> &#x2014; download dataset if not present and supported (HFDS, TFDS, torch)",name:"download"},{anchor:"timm.data.create_dataset.is_training",description:`<strong>is_training</strong> &#x2014; create dataset in train mode, this is different from the split.
For Iterable / TDFS it enables shuffle, ignored for other datasets. (TFDS, WDS)`,name:"is_training"},{anchor:"timm.data.create_dataset.batch_size",description:"<strong>batch_size</strong> &#x2014; batch size hint for (TFDS, WDS)",name:"batch_size"},{anchor:"timm.data.create_dataset.seed",description:"<strong>seed</strong> &#x2014; seed for iterable datasets (TFDS, WDS)",name:"seed"},{anchor:"timm.data.create_dataset.repeats",description:"<strong>repeats</strong> &#x2014; dataset repeats per iteration i.e. epoch (TFDS, WDS)",name:"repeats"},{anchor:"timm.data.create_dataset.input_img_mode",description:"<strong>input_img_mode</strong> &#x2014; Input image color conversion mode e.g. &#x2018;RGB&#x2019;, &#x2018;L&#x2019; (folder, TFDS, WDS, HFDS)",name:"input_img_mode"},{anchor:"timm.data.create_dataset.*kwargs",description:"*<strong>*kwargs</strong> &#x2014; other args to pass to dataset",name:"*kwargs"}],source:"https://github.com/huggingface/pytorch-image-models/blob/vr_2337/timm/data/dataset_factory.py#L63",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Dataset object</p>
`}}),_=new V({props:{name:"timm.data.create_loader",anchor:"timm.data.create_loader",parameters:[{name:"dataset",val:": Union"},{name:"input_size",val:": Union"},{name:"batch_size",val:": int"},{name:"is_training",val:": bool = False"},{name:"no_aug",val:": bool = False"},{name:"re_prob",val:": float = 0.0"},{name:"re_mode",val:": str = 'const'"},{name:"re_count",val:": int = 1"},{name:"re_split",val:": bool = False"},{name:"train_crop_mode",val:": Optional = None"},{name:"scale",val:": Optional = None"},{name:"ratio",val:": Optional = None"},{name:"hflip",val:": float = 0.5"},{name:"vflip",val:": float = 0.0"},{name:"color_jitter",val:": float = 0.4"},{name:"color_jitter_prob",val:": Optional = None"},{name:"grayscale_prob",val:": float = 0.0"},{name:"gaussian_blur_prob",val:": float = 0.0"},{name:"auto_augment",val:": Optional = None"},{name:"num_aug_repeats",val:": int = 0"},{name:"num_aug_splits",val:": int = 0"},{name:"interpolation",val:": str = 'bilinear'"},{name:"mean",val:": Tuple = (0.485, 0.456, 0.406)"},{name:"std",val:": Tuple = (0.229, 0.224, 0.225)"},{name:"num_workers",val:": int = 1"},{name:"distributed",val:": bool = False"},{name:"crop_pct",val:": Optional = None"},{name:"crop_mode",val:": Optional = None"},{name:"crop_border_pixels",val:": Optional = None"},{name:"collate_fn",val:": Optional = None"},{name:"pin_memory",val:": bool = False"},{name:"fp16",val:": bool = False"},{name:"img_dtype",val:": dtype = torch.float32"},{name:"device",val:": device = device(type='cuda')"},{name:"use_prefetcher",val:": bool = True"},{name:"use_multi_epochs_loader",val:": bool = False"},{name:"persistent_workers",val:": bool = True"},{name:"worker_seeding",val:": str = 'all'"},{name:"tf_preprocessing",val:": bool = False"}],parametersDescription:[{anchor:"timm.data.create_loader.dataset",description:"<strong>dataset</strong> &#x2014; The image dataset to load.",name:"dataset"},{anchor:"timm.data.create_loader.input_size",description:"<strong>input_size</strong> &#x2014; Target input size (channels, height, width) tuple or size scalar.",name:"input_size"},{anchor:"timm.data.create_loader.batch_size",description:"<strong>batch_size</strong> &#x2014; Number of samples in a batch.",name:"batch_size"},{anchor:"timm.data.create_loader.is_training",description:"<strong>is_training</strong> &#x2014; Return training (random) transforms.",name:"is_training"},{anchor:"timm.data.create_loader.no_aug",description:"<strong>no_aug</strong> &#x2014; Disable augmentation for training (useful for debug).",name:"no_aug"},{anchor:"timm.data.create_loader.re_prob",description:"<strong>re_prob</strong> &#x2014; Random erasing probability.",name:"re_prob"},{anchor:"timm.data.create_loader.re_mode",description:"<strong>re_mode</strong> &#x2014; Random erasing fill mode.",name:"re_mode"},{anchor:"timm.data.create_loader.re_count",description:"<strong>re_count</strong> &#x2014; Number of random erasing regions.",name:"re_count"},{anchor:"timm.data.create_loader.re_split",description:"<strong>re_split</strong> &#x2014; Control split of random erasing across batch size.",name:"re_split"},{anchor:"timm.data.create_loader.scale",description:"<strong>scale</strong> &#x2014; Random resize scale range (crop area, &lt; 1.0 =&gt; zoom in).",name:"scale"},{anchor:"timm.data.create_loader.ratio",description:"<strong>ratio</strong> &#x2014; Random aspect ratio range (crop ratio for RRC, ratio adjustment factor for RKR).",name:"ratio"},{anchor:"timm.data.create_loader.hflip",description:"<strong>hflip</strong> &#x2014; Horizontal flip probability.",name:"hflip"},{anchor:"timm.data.create_loader.vflip",description:"<strong>vflip</strong> &#x2014; Vertical flip probability.",name:"vflip"},{anchor:"timm.data.create_loader.color_jitter",description:`<strong>color_jitter</strong> &#x2014; Random color jitter component factors (brightness, contrast, saturation, hue).
Scalar is applied as (scalar,) * 3 (no hue).`,name:"color_jitter"},{anchor:"timm.data.create_loader.color_jitter_prob",description:"<strong>color_jitter_prob</strong> &#x2014; Apply color jitter with this probability if not None (for SimlCLR-like aug",name:"color_jitter_prob"},{anchor:"timm.data.create_loader.grayscale_prob",description:"<strong>grayscale_prob</strong> &#x2014; Probability of converting image to grayscale (for SimCLR-like aug).",name:"grayscale_prob"},{anchor:"timm.data.create_loader.gaussian_blur_prob",description:"<strong>gaussian_blur_prob</strong> &#x2014; Probability of applying gaussian blur (for SimCLR-like aug).",name:"gaussian_blur_prob"},{anchor:"timm.data.create_loader.auto_augment",description:"<strong>auto_augment</strong> &#x2014; Auto augment configuration string (see auto_augment.py).",name:"auto_augment"},{anchor:"timm.data.create_loader.num_aug_repeats",description:"<strong>num_aug_repeats</strong> &#x2014; Enable special sampler to repeat same augmentation across distributed GPUs.",name:"num_aug_repeats"},{anchor:"timm.data.create_loader.num_aug_splits",description:"<strong>num_aug_splits</strong> &#x2014; Enable mode where augmentations can be split across the batch.",name:"num_aug_splits"},{anchor:"timm.data.create_loader.interpolation",description:"<strong>interpolation</strong> &#x2014; Image interpolation mode.",name:"interpolation"},{anchor:"timm.data.create_loader.mean",description:"<strong>mean</strong> &#x2014; Image normalization mean.",name:"mean"},{anchor:"timm.data.create_loader.std",description:"<strong>std</strong> &#x2014; Image normalization standard deviation.",name:"std"},{anchor:"timm.data.create_loader.num_workers",description:"<strong>num_workers</strong> &#x2014; Num worker processes per DataLoader.",name:"num_workers"},{anchor:"timm.data.create_loader.distributed",description:"<strong>distributed</strong> &#x2014; Enable dataloading for distributed training.",name:"distributed"},{anchor:"timm.data.create_loader.crop_pct",description:"<strong>crop_pct</strong> &#x2014; Inference crop percentage (output size / resize size).",name:"crop_pct"},{anchor:"timm.data.create_loader.crop_mode",description:"<strong>crop_mode</strong> &#x2014; Inference crop mode. One of [&#x2018;squash&#x2019;, &#x2018;border&#x2019;, &#x2018;center&#x2019;]. Defaults to &#x2018;center&#x2019; when None.",name:"crop_mode"},{anchor:"timm.data.create_loader.crop_border_pixels",description:"<strong>crop_border_pixels</strong> &#x2014; Inference crop border of specified # pixels around edge of original image.",name:"crop_border_pixels"},{anchor:"timm.data.create_loader.collate_fn",description:"<strong>collate_fn</strong> &#x2014; Override default collate_fn.",name:"collate_fn"},{anchor:"timm.data.create_loader.pin_memory",description:"<strong>pin_memory</strong> &#x2014; Pin memory for device transfer.",name:"pin_memory"},{anchor:"timm.data.create_loader.fp16",description:"<strong>fp16</strong> &#x2014; Deprecated argument for half-precision input dtype. Use img_dtype.",name:"fp16"},{anchor:"timm.data.create_loader.img_dtype",description:"<strong>img_dtype</strong> &#x2014; Data type for input image.",name:"img_dtype"},{anchor:"timm.data.create_loader.device",description:"<strong>device</strong> &#x2014; Device to transfer inputs and targets to.",name:"device"},{anchor:"timm.data.create_loader.use_prefetcher",description:"<strong>use_prefetcher</strong> &#x2014; Use efficient pre-fetcher to load samples onto device.",name:"use_prefetcher"},{anchor:"timm.data.create_loader.use_multi_epochs_loader",description:"<strong>use_multi_epochs_loader</strong> &#x2014;",name:"use_multi_epochs_loader"},{anchor:"timm.data.create_loader.persistent_workers",description:"<strong>persistent_workers</strong> &#x2014; Enable persistent worker processes.",name:"persistent_workers"},{anchor:"timm.data.create_loader.worker_seeding",description:"<strong>worker_seeding</strong> &#x2014; Control worker random seeding at init.",name:"worker_seeding"},{anchor:"timm.data.create_loader.tf_preprocessing",description:"<strong>tf_preprocessing</strong> &#x2014; Use TF 1.0 inference preprocessing for testing model ports.",name:"tf_preprocessing"}],source:"https://github.com/huggingface/pytorch-image-models/blob/vr_2337/timm/data/loader.py#L196",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>DataLoader</p>
`}}),u=new V({props:{name:"timm.data.create_transform",anchor:"timm.data.create_transform",parameters:[{name:"input_size",val:": Union = 224"},{name:"is_training",val:": bool = False"},{name:"no_aug",val:": bool = False"},{name:"train_crop_mode",val:": Optional = None"},{name:"scale",val:": Optional = None"},{name:"ratio",val:": Optional = None"},{name:"hflip",val:": float = 0.5"},{name:"vflip",val:": float = 0.0"},{name:"color_jitter",val:": Union = 0.4"},{name:"color_jitter_prob",val:": Optional = None"},{name:"grayscale_prob",val:": float = 0.0"},{name:"gaussian_blur_prob",val:": float = 0.0"},{name:"auto_augment",val:": Optional = None"},{name:"interpolation",val:": str = 'bilinear'"},{name:"mean",val:": Tuple = (0.485, 0.456, 0.406)"},{name:"std",val:": Tuple = (0.229, 0.224, 0.225)"},{name:"re_prob",val:": float = 0.0"},{name:"re_mode",val:": str = 'const'"},{name:"re_count",val:": int = 1"},{name:"re_num_splits",val:": int = 0"},{name:"crop_pct",val:": Optional = None"},{name:"crop_mode",val:": Optional = None"},{name:"crop_border_pixels",val:": Optional = None"},{name:"tf_preprocessing",val:": bool = False"},{name:"use_prefetcher",val:": bool = False"},{name:"normalize",val:": bool = True"},{name:"separate",val:": bool = False"}],parametersDescription:[{anchor:"timm.data.create_transform.input_size",description:"<strong>input_size</strong> &#x2014; Target input size (channels, height, width) tuple or size scalar.",name:"input_size"},{anchor:"timm.data.create_transform.is_training",description:"<strong>is_training</strong> &#x2014; Return training (random) transforms.",name:"is_training"},{anchor:"timm.data.create_transform.no_aug",description:"<strong>no_aug</strong> &#x2014; Disable augmentation for training (useful for debug).",name:"no_aug"},{anchor:"timm.data.create_transform.train_crop_mode",description:"<strong>train_crop_mode</strong> &#x2014; Training random crop mode (&#x2018;rrc&#x2019;, &#x2018;rkrc&#x2019;, &#x2018;rkrr&#x2019;).",name:"train_crop_mode"},{anchor:"timm.data.create_transform.scale",description:"<strong>scale</strong> &#x2014; Random resize scale range (crop area, &lt; 1.0 =&gt; zoom in).",name:"scale"},{anchor:"timm.data.create_transform.ratio",description:"<strong>ratio</strong> &#x2014; Random aspect ratio range (crop ratio for RRC, ratio adjustment factor for RKR).",name:"ratio"},{anchor:"timm.data.create_transform.hflip",description:"<strong>hflip</strong> &#x2014; Horizontal flip probability.",name:"hflip"},{anchor:"timm.data.create_transform.vflip",description:"<strong>vflip</strong> &#x2014; Vertical flip probability.",name:"vflip"},{anchor:"timm.data.create_transform.color_jitter",description:`<strong>color_jitter</strong> &#x2014; Random color jitter component factors (brightness, contrast, saturation, hue).
Scalar is applied as (scalar,) * 3 (no hue).`,name:"color_jitter"},{anchor:"timm.data.create_transform.color_jitter_prob",description:"<strong>color_jitter_prob</strong> &#x2014; Apply color jitter with this probability if not None (for SimlCLR-like aug).",name:"color_jitter_prob"},{anchor:"timm.data.create_transform.grayscale_prob",description:"<strong>grayscale_prob</strong> &#x2014; Probability of converting image to grayscale (for SimCLR-like aug).",name:"grayscale_prob"},{anchor:"timm.data.create_transform.gaussian_blur_prob",description:"<strong>gaussian_blur_prob</strong> &#x2014; Probability of applying gaussian blur (for SimCLR-like aug).",name:"gaussian_blur_prob"},{anchor:"timm.data.create_transform.auto_augment",description:"<strong>auto_augment</strong> &#x2014; Auto augment configuration string (see auto_augment.py).",name:"auto_augment"},{anchor:"timm.data.create_transform.interpolation",description:"<strong>interpolation</strong> &#x2014; Image interpolation mode.",name:"interpolation"},{anchor:"timm.data.create_transform.mean",description:"<strong>mean</strong> &#x2014; Image normalization mean.",name:"mean"},{anchor:"timm.data.create_transform.std",description:"<strong>std</strong> &#x2014; Image normalization standard deviation.",name:"std"},{anchor:"timm.data.create_transform.re_prob",description:"<strong>re_prob</strong> &#x2014; Random erasing probability.",name:"re_prob"},{anchor:"timm.data.create_transform.re_mode",description:"<strong>re_mode</strong> &#x2014; Random erasing fill mode.",name:"re_mode"},{anchor:"timm.data.create_transform.re_count",description:"<strong>re_count</strong> &#x2014; Number of random erasing regions.",name:"re_count"},{anchor:"timm.data.create_transform.re_num_splits",description:"<strong>re_num_splits</strong> &#x2014; Control split of random erasing across batch size.",name:"re_num_splits"},{anchor:"timm.data.create_transform.crop_pct",description:"<strong>crop_pct</strong> &#x2014; Inference crop percentage (output size / resize size).",name:"crop_pct"},{anchor:"timm.data.create_transform.crop_mode",description:"<strong>crop_mode</strong> &#x2014; Inference crop mode. One of [&#x2018;squash&#x2019;, &#x2018;border&#x2019;, &#x2018;center&#x2019;]. Defaults to &#x2018;center&#x2019; when None.",name:"crop_mode"},{anchor:"timm.data.create_transform.crop_border_pixels",description:"<strong>crop_border_pixels</strong> &#x2014; Inference crop border of specified # pixels around edge of original image.",name:"crop_border_pixels"},{anchor:"timm.data.create_transform.tf_preprocessing",description:"<strong>tf_preprocessing</strong> &#x2014; Use TF 1.0 inference preprocessing for testing model ports",name:"tf_preprocessing"},{anchor:"timm.data.create_transform.use_prefetcher",description:"<strong>use_prefetcher</strong> &#x2014; Pre-fetcher enabled. Do not convert image to tensor or normalize.",name:"use_prefetcher"},{anchor:"timm.data.create_transform.normalize",description:"<strong>normalize</strong> &#x2014; Normalization tensor output w/ provided mean/std (if prefetcher not used).",name:"normalize"},{anchor:"timm.data.create_transform.separate",description:"<strong>separate</strong> &#x2014; Output transforms in 3-stage tuple.",name:"separate"}],source:"https://github.com/huggingface/pytorch-image-models/blob/vr_2337/timm/data/transforms_factory.py#L334",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Composed transforms or tuple thereof</p>
`}}),b=new V({props:{name:"timm.data.resolve_data_config",anchor:"timm.data.resolve_data_config",parameters:[{name:"args",val:" = None"},{name:"pretrained_cfg",val:" = None"},{name:"model",val:" = None"},{name:"use_test_size",val:" = False"},{name:"verbose",val:" = False"}],source:"https://github.com/huggingface/pytorch-image-models/blob/vr_2337/timm/data/config.py#L8"}}),v=new me({props:{source:"https://github.com/huggingface/pytorch-image-models/blob/main/hfdocs/source/reference/data.mdx"}}),{c(){c=s("meta"),I=n(),T=s("p"),C=n(),D(d.$$.fragment),L=n(),o=s("div"),D(p.$$.fragment),G=n(),y=s("p"),y.textContent=J,M=n(),$=s("p"),$.textContent=Q,q=n(),z=s("ul"),z.innerHTML=X,P=n(),g=s("div"),D(_.$$.fragment),E=n(),f=s("div"),D(u.$$.fragment),U=n(),h=s("div"),D(b.$$.fragment),H=n(),D(v.$$.fragment),W=n(),O=s("p"),this.h()},l(e){const a=ie("svelte-u9bgzb",document.head);c=m(a,"META",{name:!0,content:!0}),a.forEach(t),I=i(e),T=m(e,"P",{}),w(T).forEach(t),C=i(e),F(d.$$.fragment,e),L=i(e),o=m(e,"DIV",{class:!0});var l=w(o);F(p.$$.fragment,l),G=i(l),y=m(l,"P",{"data-svelte-h":!0}),B(y)!=="svelte-1tv23x9"&&(y.textContent=J),M=i(l),$=m(l,"P",{"data-svelte-h":!0}),B($)!=="svelte-1k3tjcx"&&($.textContent=Q),q=i(l),z=m(l,"UL",{"data-svelte-h":!0}),B(z)!=="svelte-1joatkj"&&(z.innerHTML=X),l.forEach(t),P=i(e),g=m(e,"DIV",{class:!0});var Y=w(g);F(_.$$.fragment,Y),Y.forEach(t),E=i(e),f=m(e,"DIV",{class:!0});var Z=w(f);F(u.$$.fragment,Z),Z.forEach(t),U=i(e),h=m(e,"DIV",{class:!0});var ee=w(h);F(b.$$.fragment,ee),ee.forEach(t),H=i(e),F(v.$$.fragment,e),W=i(e),O=m(e,"P",{}),w(O).forEach(t),this.h()},h(){N(c,"name","hf:doc:metadata"),N(c,"content",le),N(o,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),N(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),N(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),N(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,a){x(document.head,c),r(e,I,a),r(e,T,a),r(e,C,a),k(d,e,a),r(e,L,a),r(e,o,a),k(p,o,null),x(o,G),x(o,y),x(o,M),x(o,$),x(o,q),x(o,z),r(e,P,a),r(e,g,a),k(_,g,null),r(e,E,a),r(e,f,a),k(u,f,null),r(e,U,a),r(e,h,a),k(b,h,null),r(e,H,a),k(v,e,a),r(e,W,a),r(e,O,a),A=!0},p:ae,i(e){A||(R(d.$$.fragment,e),R(p.$$.fragment,e),R(_.$$.fragment,e),R(u.$$.fragment,e),R(b.$$.fragment,e),R(v.$$.fragment,e),A=!0)},o(e){S(d.$$.fragment,e),S(p.$$.fragment,e),S(_.$$.fragment,e),S(u.$$.fragment,e),S(b.$$.fragment,e),S(v.$$.fragment,e),A=!1},d(e){e&&(t(I),t(T),t(C),t(L),t(o),t(P),t(g),t(E),t(f),t(U),t(h),t(H),t(W),t(O)),t(c),j(d,e),j(p),j(_),j(u),j(b),j(v,e)}}}const le='{"title":"Data","local":"timm.data.create_dataset","sections":[],"depth":1}';function de(K){return re(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ue extends oe{constructor(c){super(),ne(this,c,de,ce,te,{})}}export{ue as component};
